"use strict";

// FIXME probably there is a jquery plugin to hide the browser support,
// or maybe we can just requuire browsers new enough to use the standard?
// This is wrapper is easy enough...
define(function () {
    return {
        get enabled () {
            return document.fullscreenEnabled ||
                   document.webkitFullscreenEnabled ||
                   document.mozFullScreenEnabled ||
                   document.msFullscreenEnabled;
        },

        get element () {
            return document.fullscreenElement ||
                   document.mozFullScreenElement ||
                   document.webkitFullscreenElement ||
                   document.msFullscreenElement;
        },

        request: function (elem) {
            if (elem.requestFullscreen) {
                elem.requestFullscreen();
            } else if (document.documentElement.mozRequestFullScreen) {
                elem.mozRequestFullScreen();
            } else if (document.documentElement.webkitRequestFullscreen) {
                elem.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);
            } else if (document.documentElement.msRequestFullscreen) {
                elem.msRequestFullscreen();
            }
        },

        exit: function () {
            if (document.exitFullscreen) {
                document.exitFullscreen();
            } else if (document.mozCancelFullScreen) {
                document.mozCancelFullScreen();
            } else if (document.webkitExitFullscreen) {
                document.webkitExitFullscreen();
            } else if (document.msExitFullscreen) {
                document.msExitFullscreen();
            }
        },

        addEventListener: function (handler) {
            document.addEventListener("fullscreenchange", handler, false);
            document.addEventListener("webkitfullscreenchange", handler, false);
            document.addEventListener("mozfullscreenchange", handler, false);
            document.addEventListener("MSFullscreenChange", handler, false);
        }
    };
});

/* ex:set ts=4 et: */
