"use strict";

define([
    "jquery",
    "text!images/photon/photon-icon-add-folder.svg",
    "text!images/photon/photon-icon-alert-notification.svg",
    "text!images/photon/photon-icon-arrow-down.svg",
    "text!images/photon/photon-icon-arrow-left.svg",
    "text!images/photon/photon-icon-arrow-right.svg",
    "text!images/photon/photon-icon-arrow-up.svg",
    "text!images/photon/photon-icon-audio-off.svg",
    "text!images/photon/photon-icon-audio-low.svg",
    "text!images/photon/photon-icon-audio-medium.svg",
    "text!images/photon/photon-icon-audio-on.svg",
    "text!images/photon/photon-icon-audio.svg",
    "text!images/photon/photon-icon-checked-lg.svg",
    "text!images/photon/photon-icon-checked-solid-lg.svg",
    "text!images/photon/photon-icon-checked.svg",
    "text!images/photon/photon-icon-check-inactive.svg",
    "text!images/photon/photon-icon-check-off.svg",
    "text!images/photon/photon-icon-check-press.svg",
    "text!images/photon/photon-icon-check-selected.svg",
    "text!images/photon/photon-icon-close.svg",
    "text!images/photon/photon-icon-cloud.svg",
    "text!images/photon/photon-icon-cloud-sync.svg",
    "text!images/photon/photon-icon-confirm-notification.svg",
    "text!images/photon/photon-icon-connection-settings.svg",
    "text!images/photon/photon-icon-crosshair.svg",
    "text!images/photon/photon-icon-copy-to-clipboard.svg",
    "text!images/photon/photon-icon-delete.svg",
    "text!images/photon/photon-icon-document.svg",
    "text!images/photon/photon-icon-download-classic.svg",
    "text!images/photon/photon-icon-download-from-cloud.svg",
    "text!images/photon/photon-icon-download.svg",
    "text!images/photon/photon-icon-edit.svg",
    "text!images/photon/photon-icon-error-notification.svg",
    "text!images/photon/photon-icon-from-clipboard.svg",
    "text!images/photon/photon-icon-full-screen.svg",
    "text!images/photon/photon-icon-help.svg",
    "text!images/photon/photon-icon-icon-view.svg",
    "text!images/photon/photon-icon-info-notification.svg",
    "text!images/photon/photon-icon-info.svg",
    "text!images/photon/photon-icon-keyboard.svg",
    "text!images/photon/photon-icon-leave-full-screen.svg",
    "text!images/photon/photon-icon-list-view.svg",
    "text!images/photon/photon-icon-logout.svg",
    "text!images/photon/photon-icon-more-horizontal.svg",
    "text!images/photon/photon-icon-more-vertical.svg",
    "text!images/photon/photon-icon-muted.svg",
    "text!images/photon/photon-icon-notifications.svg",
    "text!images/photon/photon-icon-open-folder.svg",
    "text!images/photon/photon-icon-open-with.svg",
    "text!images/photon/photon-icon-profile.svg",
    "text!images/photon/photon-icon-radio-ff.svg",
    "text!images/photon/photon-icon-radio-inactive.svg",
    "text!images/photon/photon-icon-radio-press.svg",
    "text!images/photon/photon-icon-radio-selected.svg",
    "text!images/photon/photon-icon-screen.svg",
    "text!images/photon/photon-icon-search.svg",
    "text!images/photon/photon-icon-send-feedback.svg",
    "text!images/photon/photon-icon-settings.svg",
    "text!images/photon/photon-icon-smile.svg",
    "text!images/photon/photon-icon-star.svg",
    "text!images/photon/photon-icon-storage-download.svg",
    "text!images/photon/photon-icon-storage.svg",
    "text!images/photon/photon-icon-storage-upload.svg",
    "text!images/photon/photon-icon-to-clipboard.svg",
    "text!images/photon/photon-icon-unchecked-lg.svg",
    "text!images/photon/photon-icon-unmuted.svg",
    "text!images/photon/photon-icon-upload.svg",
    "text!images/photon/photon-icon-upload-to-cloud.svg"
],
function (
    $,
    addFolderIcon,
    alertNotificationIcon,
    arrowDownIcon,
    arrowLeftIcon,
    arrowRightIcon,
    arrowUpIcon,
    audioOffIcon,
    audioLowIcon,
    audioMediumIcon,
    audioOnIcon,
    audioIcon,
    checkedLgIcon,
    checkedSolidLgIcon,
    checkedIcon,
    checkInactiveIcon,
    checkOffIcon,
    checkPressIcon,
    checkSelectedIcon,
    closeIcon,
    cloudIcon,
    cloudSyncIcon,
    confirmNotificationIcon,
    connectionSettingsIcon,
    crosshairIcon,
    copyToClipboardIcon,
    deleteIcon,
    documentIcon,
    downloadClassicIcon,
    downloadFromCloudIcon,
    downloadIcon,
    editIcon,
    errorNotificationIcon,
    fromClipboardIcon,
    fullScreenIcon,
    helpIcon,
    iconViewIcon,
    infoNotificationIcon,
    infoIcon,
    keyboardIcon,
    leaveFullScreenIcon,
    listViewIcon,
    logoutIcon,
    moreHorizontalIcon,
    moreVerticalIcon,
    mutedIcon,
    notificationsIcon,
    openFolderIcon,
    openWithIcon,
    profileIcon,
    radioFfIcon,
    radioInactiveIcon,
    radioPressIcon,
    radioSelectedIcon,
    screenIcon,
    searchIcon,
    sendFeedbackIcon,
    settingsIcon,
    smileIcon,
    starIcon,
    storageDownloadIcon,
    storageIcon,
    storageUploadIcon,
    toClipboardIcon,
    uncheckedLgIcon,
    unmutedIcon,
    uploadIcon,
    uploadToCloudIcon
) {
    var icons = {
        "add-folder": addFolderIcon,
        "alert-notification": alertNotificationIcon,
        "arrow-down": arrowDownIcon,
        "arrow-left": arrowLeftIcon,
        "arrow-right": arrowRightIcon,
        "arrow-up": arrowUpIcon,
        "audio-off": audioOffIcon,
        "audio-low": audioLowIcon,
        "audio-medium": audioMediumIcon,
        "audio-on": audioOnIcon,
        "audio": audioIcon,
        "checked-lg": checkedLgIcon,
        "checked-solid-lg": checkedSolidLgIcon,
        "checked": checkedIcon,
        "check-inactive": checkInactiveIcon,
        "check-off": checkOffIcon,
        "check-press": checkPressIcon,
        "check-selected": checkSelectedIcon,
        "close": closeIcon,
        "cloud": cloudIcon,
        "cloud-sync": cloudSyncIcon,
        "confirm-notification": confirmNotificationIcon,
        "connection-settings": connectionSettingsIcon,
        "icon-crosshair": crosshairIcon,
        "copy-to-clipboard": copyToClipboardIcon,
        "delete": deleteIcon,
        "document": documentIcon,
        "download-classic": downloadClassicIcon,
        "download-from-cloud": downloadFromCloudIcon,
        "download": downloadIcon,
        "edit": editIcon,
        "error-notification": errorNotificationIcon,
        "from-flipboard": fromClipboardIcon,
        "full-screen": fullScreenIcon,
        "help": helpIcon,
        "icon-view": iconViewIcon,
        "info-notification": infoNotificationIcon,
        "info": infoIcon,
        "keyboard": keyboardIcon,
        "leave-full-screen": leaveFullScreenIcon,
        "list-view": listViewIcon,
        "logout": logoutIcon,
        "more-horizontal": moreHorizontalIcon,
        "more-vertical": moreVerticalIcon,
        "muted": mutedIcon,
        "notifications": notificationsIcon,
        "open-folder": openFolderIcon,
        "open-with": openWithIcon,
        "profile": profileIcon,
        "radio-ff": radioFfIcon,
        "radio-inactive": radioInactiveIcon,
        "radio-press": radioPressIcon,
        "radio-selected": radioSelectedIcon,
        "screen": screenIcon,
        "search": searchIcon,
        "send-feedback": sendFeedbackIcon,
        "settings": settingsIcon,
        "smile": smileIcon,
        "star": starIcon,
        "storage-download": storageDownloadIcon,
        "storage": storageIcon,
        "storage-upload": storageUploadIcon,
        "to-clipboard": toClipboardIcon,
        "unchecked-lg": uncheckedLgIcon,
        "unmuted": unmutedIcon,
        "upload": uploadIcon,
        "upload-to-cloud": uploadToCloudIcon,

        "setupPhotonIcons": function () {

            /* eslint-disable no-invalid-this */
            $(".photon-icon").each(function () {
                var iconName = $(this).text();

                if (icons.hasOwnProperty(iconName)) {
                    $(this).replaceWith(icons[iconName]);
                }
            });

            /* eslint-enable no-invalid-this */
        }
    };

    return icons;
});

/* ex:set ts=4 et: */
