"use strict";

define([
    "jquery",
    "loglevel",
    "./icons",
    "./settings"
],
function ($, loglevel, icons, settings) {
    var connection,
        builtinShortcuts = [{
            sequence: [
                {key: "Control", location: KeyboardEvent.DOM_KEY_LOCATION_LEFT},
                {key: "Alt", location: KeyboardEvent.DOM_KEY_LOCATION_LEFT},
                {key: "End", location: KeyboardEvent.DOM_KEY_LOCATION_STANDARD}
            ],
            output: [
                {key: "Control", location: KeyboardEvent.DOM_KEY_LOCATION_LEFT},
                {key: "Alt", location: KeyboardEvent.DOM_KEY_LOCATION_LEFT},
                {key: "Delete", location: KeyboardEvent.DOM_KEY_LOCATION_STANDARD}
            ]
        }];

    function onModalHide (e) {
        builtinShortcuts = JSON.parse($("#dcv-shortcut-textarea").val());
        connection.registerKeyboardShortcuts(builtinShortcuts);
    }

    function onModalShow (e) {
        $("#dcv-shortcut-textarea").val(JSON.stringify(builtinShortcuts, null, 4));
    }

    return {
        setup: function (editMenu, conn) {
            connection = conn;

            connection.registerKeyboardShortcuts(builtinShortcuts);

            if (settings.enableShortcutEditor) {
                editMenu.parent().removeClass("hidden").show();

                $("#dcv-shortcut").on("hide.bs.modal", onModalHide);
                $("#dcv-shortcut").on("show.bs.modal", onModalShow);
            }
        }
    };
});
