"use strict";

define([
    "jquery",
    "loglevel",
    "./icons",
    "./settings",
    "./utils",
    "text!templates/postsession.html",
    "text!images/dcv.svg",
    "bootstrap"
],
function ($, loglevel, icons, settings, utils, postSessionTemplate, logo) {
    var log,
        postSessionDiv;

    /* The reason message must be 30 chars long, at maximum */
    function show (reason, isError, allowReconnect) {
        var msg = "The connection has been closed";

        log = loglevel.getLogger("postsession");

        if (reason && reason.message !== "") {
            msg += "<BR />" + reason.message;
        }

        log.debug("Show post-session: " + msg);

        postSessionDiv = $(postSessionTemplate).appendTo(document.body);

        $(".dcv-logo", postSessionDiv).append(logo);
        $(".dcv-postsession-message span", postSessionDiv).html(msg);

        if (isError) {
            $(".dcv-postsession-message", postSessionDiv).addClass("error");
            $(".dcv-postsession-message .photon-icon", postSessionDiv).replaceWith(icons["error-notification"]);
        }

        if (typeof allowReconnect !== "undefined" && allowReconnect === false) {
            $("button", postSessionDiv).remove();
        } else {
            $("button", postSessionDiv).click(function () {
                document.location.reload();
            });
        }
    }

    return {
        showReason: show,

        showError: function (error, allowReconnect) {
            if (error && error.message) {
                show(error.message, true, allowReconnect);
            } else {
                show("", true, allowReconnect);
            }
        }
    };
});

/* ex:set ts=4 et: */
