/*eslint-disable block-scoped-var, no-redeclare, no-control-regex, no-prototype-builtins*/
define(["protobufjs/minimal"], function($protobuf) {
    "use strict";

    // Common aliases
    var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;
    
    // Exported root namespace
    var $root = $protobuf.roots["dcv.auth"] || ($protobuf.roots["dcv.auth"] = {});
    
    $root.dcv = (function() {
    
        /**
         * Namespace dcv.
         * @exports dcv
         * @namespace
         */
        var dcv = {};
    
        dcv.auth = (function() {
    
            /**
             * Namespace auth.
             * @memberof dcv
             * @namespace
             */
            var auth = {};
    
            auth.AuthenticationRequest = (function() {
    
                /**
                 * Properties of an AuthenticationRequest.
                 * @memberof dcv.auth
                 * @interface IAuthenticationRequest
                 */
    
                /**
                 * Constructs a new AuthenticationRequest.
                 * @memberof dcv.auth
                 * @classdesc Represents an AuthenticationRequest.
                 * @implements IAuthenticationRequest
                 * @constructor
                 * @param {dcv.auth.IAuthenticationRequest=} [properties] Properties to set
                 */
                function AuthenticationRequest(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Creates a new AuthenticationRequest instance using the specified properties.
                 * @function create
                 * @memberof dcv.auth.AuthenticationRequest
                 * @static
                 * @param {dcv.auth.IAuthenticationRequest=} [properties] Properties to set
                 * @returns {dcv.auth.AuthenticationRequest} AuthenticationRequest instance
                 */
                AuthenticationRequest.create = function create(properties) {
                    return new AuthenticationRequest(properties);
                };
    
                /**
                 * Encodes the specified AuthenticationRequest message. Does not implicitly {@link dcv.auth.AuthenticationRequest.verify|verify} messages.
                 * @function encode
                 * @memberof dcv.auth.AuthenticationRequest
                 * @static
                 * @param {dcv.auth.IAuthenticationRequest} message AuthenticationRequest message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                AuthenticationRequest.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    return writer;
                };
    
                /**
                 * Encodes the specified AuthenticationRequest message, length delimited. Does not implicitly {@link dcv.auth.AuthenticationRequest.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof dcv.auth.AuthenticationRequest
                 * @static
                 * @param {dcv.auth.IAuthenticationRequest} message AuthenticationRequest message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                AuthenticationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an AuthenticationRequest message from the specified reader or buffer.
                 * @function decode
                 * @memberof dcv.auth.AuthenticationRequest
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {dcv.auth.AuthenticationRequest} AuthenticationRequest
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                AuthenticationRequest.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.AuthenticationRequest();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an AuthenticationRequest message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof dcv.auth.AuthenticationRequest
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {dcv.auth.AuthenticationRequest} AuthenticationRequest
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                AuthenticationRequest.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an AuthenticationRequest message.
                 * @function verify
                 * @memberof dcv.auth.AuthenticationRequest
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                AuthenticationRequest.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    return null;
                };
    
                /**
                 * Creates an AuthenticationRequest message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof dcv.auth.AuthenticationRequest
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {dcv.auth.AuthenticationRequest} AuthenticationRequest
                 */
                AuthenticationRequest.fromObject = function fromObject(object) {
                    if (object instanceof $root.dcv.auth.AuthenticationRequest)
                        return object;
                    return new $root.dcv.auth.AuthenticationRequest();
                };
    
                /**
                 * Creates a plain object from an AuthenticationRequest message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof dcv.auth.AuthenticationRequest
                 * @static
                 * @param {dcv.auth.AuthenticationRequest} message AuthenticationRequest
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                AuthenticationRequest.toObject = function toObject() {
                    return {};
                };
    
                /**
                 * Converts this AuthenticationRequest to JSON.
                 * @function toJSON
                 * @memberof dcv.auth.AuthenticationRequest
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                AuthenticationRequest.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                return AuthenticationRequest;
            })();
    
            auth.AuthenticationInit = (function() {
    
                /**
                 * Properties of an AuthenticationInit.
                 * @memberof dcv.auth
                 * @interface IAuthenticationInit
                 * @property {string|null} [authenticationMode] AuthenticationInit authenticationMode
                 * @property {Array.<string>|null} [mechanisms] A list of SASL mechanisms supported by the server for this channel connection
                 */
    
                /**
                 * Constructs a new AuthenticationInit.
                 * @memberof dcv.auth
                 * @classdesc Represents an AuthenticationInit.
                 * @implements IAuthenticationInit
                 * @constructor
                 * @param {dcv.auth.IAuthenticationInit=} [properties] Properties to set
                 */
                function AuthenticationInit(properties) {
                    this.mechanisms = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * AuthenticationInit authenticationMode.
                 * @member {string} authenticationMode
                 * @memberof dcv.auth.AuthenticationInit
                 * @instance
                 */
                AuthenticationInit.prototype.authenticationMode = "";
    
                /**
                 * A list of SASL mechanisms supported by the server for this channel connection
                 * @member {Array.<string>} mechanisms
                 * @memberof dcv.auth.AuthenticationInit
                 * @instance
                 */
                AuthenticationInit.prototype.mechanisms = $util.emptyArray;
    
                /**
                 * Creates a new AuthenticationInit instance using the specified properties.
                 * @function create
                 * @memberof dcv.auth.AuthenticationInit
                 * @static
                 * @param {dcv.auth.IAuthenticationInit=} [properties] Properties to set
                 * @returns {dcv.auth.AuthenticationInit} AuthenticationInit instance
                 */
                AuthenticationInit.create = function create(properties) {
                    return new AuthenticationInit(properties);
                };
    
                /**
                 * Encodes the specified AuthenticationInit message. Does not implicitly {@link dcv.auth.AuthenticationInit.verify|verify} messages.
                 * @function encode
                 * @memberof dcv.auth.AuthenticationInit
                 * @static
                 * @param {dcv.auth.IAuthenticationInit} message AuthenticationInit message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                AuthenticationInit.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.authenticationMode != null && message.hasOwnProperty("authenticationMode"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.authenticationMode);
                    if (message.mechanisms != null && message.mechanisms.length)
                        for (var i = 0; i < message.mechanisms.length; ++i)
                            writer.uint32(/* id 10, wireType 2 =*/82).string(message.mechanisms[i]);
                    return writer;
                };
    
                /**
                 * Encodes the specified AuthenticationInit message, length delimited. Does not implicitly {@link dcv.auth.AuthenticationInit.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof dcv.auth.AuthenticationInit
                 * @static
                 * @param {dcv.auth.IAuthenticationInit} message AuthenticationInit message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                AuthenticationInit.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an AuthenticationInit message from the specified reader or buffer.
                 * @function decode
                 * @memberof dcv.auth.AuthenticationInit
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {dcv.auth.AuthenticationInit} AuthenticationInit
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                AuthenticationInit.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.AuthenticationInit();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.authenticationMode = reader.string();
                            break;
                        case 10:
                            if (!(message.mechanisms && message.mechanisms.length))
                                message.mechanisms = [];
                            message.mechanisms.push(reader.string());
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an AuthenticationInit message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof dcv.auth.AuthenticationInit
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {dcv.auth.AuthenticationInit} AuthenticationInit
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                AuthenticationInit.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an AuthenticationInit message.
                 * @function verify
                 * @memberof dcv.auth.AuthenticationInit
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                AuthenticationInit.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.authenticationMode != null && message.hasOwnProperty("authenticationMode"))
                        if (!$util.isString(message.authenticationMode))
                            return "authenticationMode: string expected";
                    if (message.mechanisms != null && message.hasOwnProperty("mechanisms")) {
                        if (!Array.isArray(message.mechanisms))
                            return "mechanisms: array expected";
                        for (var i = 0; i < message.mechanisms.length; ++i)
                            if (!$util.isString(message.mechanisms[i]))
                                return "mechanisms: string[] expected";
                    }
                    return null;
                };
    
                /**
                 * Creates an AuthenticationInit message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof dcv.auth.AuthenticationInit
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {dcv.auth.AuthenticationInit} AuthenticationInit
                 */
                AuthenticationInit.fromObject = function fromObject(object) {
                    if (object instanceof $root.dcv.auth.AuthenticationInit)
                        return object;
                    var message = new $root.dcv.auth.AuthenticationInit();
                    if (object.authenticationMode != null)
                        message.authenticationMode = String(object.authenticationMode);
                    if (object.mechanisms) {
                        if (!Array.isArray(object.mechanisms))
                            throw TypeError(".dcv.auth.AuthenticationInit.mechanisms: array expected");
                        message.mechanisms = [];
                        for (var i = 0; i < object.mechanisms.length; ++i)
                            message.mechanisms[i] = String(object.mechanisms[i]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an AuthenticationInit message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof dcv.auth.AuthenticationInit
                 * @static
                 * @param {dcv.auth.AuthenticationInit} message AuthenticationInit
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                AuthenticationInit.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.mechanisms = [];
                    if (options.defaults)
                        object.authenticationMode = "";
                    if (message.authenticationMode != null && message.hasOwnProperty("authenticationMode"))
                        object.authenticationMode = message.authenticationMode;
                    if (message.mechanisms && message.mechanisms.length) {
                        object.mechanisms = [];
                        for (var j = 0; j < message.mechanisms.length; ++j)
                            object.mechanisms[j] = message.mechanisms[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this AuthenticationInit to JSON.
                 * @function toJSON
                 * @memberof dcv.auth.AuthenticationInit
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                AuthenticationInit.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                return AuthenticationInit;
            })();
    
            auth.SaslStart = (function() {
    
                /**
                 * Properties of a SaslStart.
                 * @memberof dcv.auth
                 * @interface ISaslStart
                 * @property {string|null} [mechanism] The SASL mechanism selected by the client
                 * @property {Uint8Array|null} [authData] The response to the initial challenge (if requested by the selected mechanism)
                 */
    
                /**
                 * Constructs a new SaslStart.
                 * @memberof dcv.auth
                 * @classdesc Represents a SaslStart.
                 * @implements ISaslStart
                 * @constructor
                 * @param {dcv.auth.ISaslStart=} [properties] Properties to set
                 */
                function SaslStart(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * The SASL mechanism selected by the client
                 * @member {string} mechanism
                 * @memberof dcv.auth.SaslStart
                 * @instance
                 */
                SaslStart.prototype.mechanism = "";
    
                /**
                 * The response to the initial challenge (if requested by the selected mechanism)
                 * @member {Uint8Array} authData
                 * @memberof dcv.auth.SaslStart
                 * @instance
                 */
                SaslStart.prototype.authData = $util.newBuffer([]);
    
                /**
                 * Creates a new SaslStart instance using the specified properties.
                 * @function create
                 * @memberof dcv.auth.SaslStart
                 * @static
                 * @param {dcv.auth.ISaslStart=} [properties] Properties to set
                 * @returns {dcv.auth.SaslStart} SaslStart instance
                 */
                SaslStart.create = function create(properties) {
                    return new SaslStart(properties);
                };
    
                /**
                 * Encodes the specified SaslStart message. Does not implicitly {@link dcv.auth.SaslStart.verify|verify} messages.
                 * @function encode
                 * @memberof dcv.auth.SaslStart
                 * @static
                 * @param {dcv.auth.ISaslStart} message SaslStart message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SaslStart.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.mechanism != null && message.hasOwnProperty("mechanism"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.mechanism);
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        writer.uint32(/* id 10, wireType 2 =*/82).bytes(message.authData);
                    return writer;
                };
    
                /**
                 * Encodes the specified SaslStart message, length delimited. Does not implicitly {@link dcv.auth.SaslStart.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof dcv.auth.SaslStart
                 * @static
                 * @param {dcv.auth.ISaslStart} message SaslStart message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SaslStart.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a SaslStart message from the specified reader or buffer.
                 * @function decode
                 * @memberof dcv.auth.SaslStart
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {dcv.auth.SaslStart} SaslStart
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SaslStart.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.SaslStart();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.mechanism = reader.string();
                            break;
                        case 10:
                            message.authData = reader.bytes();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a SaslStart message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof dcv.auth.SaslStart
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {dcv.auth.SaslStart} SaslStart
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SaslStart.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a SaslStart message.
                 * @function verify
                 * @memberof dcv.auth.SaslStart
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                SaslStart.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.mechanism != null && message.hasOwnProperty("mechanism"))
                        if (!$util.isString(message.mechanism))
                            return "mechanism: string expected";
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        if (!(message.authData && typeof message.authData.length === "number" || $util.isString(message.authData)))
                            return "authData: buffer expected";
                    return null;
                };
    
                /**
                 * Creates a SaslStart message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof dcv.auth.SaslStart
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {dcv.auth.SaslStart} SaslStart
                 */
                SaslStart.fromObject = function fromObject(object) {
                    if (object instanceof $root.dcv.auth.SaslStart)
                        return object;
                    var message = new $root.dcv.auth.SaslStart();
                    if (object.mechanism != null)
                        message.mechanism = String(object.mechanism);
                    if (object.authData != null)
                        if (typeof object.authData === "string")
                            $util.base64.decode(object.authData, message.authData = $util.newBuffer($util.base64.length(object.authData)), 0);
                        else if (object.authData.length)
                            message.authData = object.authData;
                    return message;
                };
    
                /**
                 * Creates a plain object from a SaslStart message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof dcv.auth.SaslStart
                 * @static
                 * @param {dcv.auth.SaslStart} message SaslStart
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                SaslStart.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.mechanism = "";
                        object.authData = options.bytes === String ? "" : [];
                    }
                    if (message.mechanism != null && message.hasOwnProperty("mechanism"))
                        object.mechanism = message.mechanism;
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        object.authData = options.bytes === String ? $util.base64.encode(message.authData, 0, message.authData.length) : options.bytes === Array ? Array.prototype.slice.call(message.authData) : message.authData;
                    return object;
                };
    
                /**
                 * Converts this SaslStart to JSON.
                 * @function toJSON
                 * @memberof dcv.auth.SaslStart
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                SaslStart.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                return SaslStart;
            })();
    
            auth.SaslChallenge = (function() {
    
                /**
                 * Properties of a SaslChallenge.
                 * @memberof dcv.auth
                 * @interface ISaslChallenge
                 * @property {Uint8Array|null} [authData] The challenge requested by the server
                 */
    
                /**
                 * Constructs a new SaslChallenge.
                 * @memberof dcv.auth
                 * @classdesc Represents a SaslChallenge.
                 * @implements ISaslChallenge
                 * @constructor
                 * @param {dcv.auth.ISaslChallenge=} [properties] Properties to set
                 */
                function SaslChallenge(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * The challenge requested by the server
                 * @member {Uint8Array} authData
                 * @memberof dcv.auth.SaslChallenge
                 * @instance
                 */
                SaslChallenge.prototype.authData = $util.newBuffer([]);
    
                /**
                 * Creates a new SaslChallenge instance using the specified properties.
                 * @function create
                 * @memberof dcv.auth.SaslChallenge
                 * @static
                 * @param {dcv.auth.ISaslChallenge=} [properties] Properties to set
                 * @returns {dcv.auth.SaslChallenge} SaslChallenge instance
                 */
                SaslChallenge.create = function create(properties) {
                    return new SaslChallenge(properties);
                };
    
                /**
                 * Encodes the specified SaslChallenge message. Does not implicitly {@link dcv.auth.SaslChallenge.verify|verify} messages.
                 * @function encode
                 * @memberof dcv.auth.SaslChallenge
                 * @static
                 * @param {dcv.auth.ISaslChallenge} message SaslChallenge message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SaslChallenge.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        writer.uint32(/* id 1, wireType 2 =*/10).bytes(message.authData);
                    return writer;
                };
    
                /**
                 * Encodes the specified SaslChallenge message, length delimited. Does not implicitly {@link dcv.auth.SaslChallenge.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof dcv.auth.SaslChallenge
                 * @static
                 * @param {dcv.auth.ISaslChallenge} message SaslChallenge message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SaslChallenge.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a SaslChallenge message from the specified reader or buffer.
                 * @function decode
                 * @memberof dcv.auth.SaslChallenge
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {dcv.auth.SaslChallenge} SaslChallenge
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SaslChallenge.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.SaslChallenge();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.authData = reader.bytes();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a SaslChallenge message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof dcv.auth.SaslChallenge
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {dcv.auth.SaslChallenge} SaslChallenge
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SaslChallenge.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a SaslChallenge message.
                 * @function verify
                 * @memberof dcv.auth.SaslChallenge
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                SaslChallenge.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        if (!(message.authData && typeof message.authData.length === "number" || $util.isString(message.authData)))
                            return "authData: buffer expected";
                    return null;
                };
    
                /**
                 * Creates a SaslChallenge message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof dcv.auth.SaslChallenge
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {dcv.auth.SaslChallenge} SaslChallenge
                 */
                SaslChallenge.fromObject = function fromObject(object) {
                    if (object instanceof $root.dcv.auth.SaslChallenge)
                        return object;
                    var message = new $root.dcv.auth.SaslChallenge();
                    if (object.authData != null)
                        if (typeof object.authData === "string")
                            $util.base64.decode(object.authData, message.authData = $util.newBuffer($util.base64.length(object.authData)), 0);
                        else if (object.authData.length)
                            message.authData = object.authData;
                    return message;
                };
    
                /**
                 * Creates a plain object from a SaslChallenge message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof dcv.auth.SaslChallenge
                 * @static
                 * @param {dcv.auth.SaslChallenge} message SaslChallenge
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                SaslChallenge.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.authData = options.bytes === String ? "" : [];
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        object.authData = options.bytes === String ? $util.base64.encode(message.authData, 0, message.authData.length) : options.bytes === Array ? Array.prototype.slice.call(message.authData) : message.authData;
                    return object;
                };
    
                /**
                 * Converts this SaslChallenge to JSON.
                 * @function toJSON
                 * @memberof dcv.auth.SaslChallenge
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                SaslChallenge.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                return SaslChallenge;
            })();
    
            auth.SaslStep = (function() {
    
                /**
                 * Properties of a SaslStep.
                 * @memberof dcv.auth
                 * @interface ISaslStep
                 * @property {Uint8Array|null} [authData] The response to the challenge
                 */
    
                /**
                 * Constructs a new SaslStep.
                 * @memberof dcv.auth
                 * @classdesc Represents a SaslStep.
                 * @implements ISaslStep
                 * @constructor
                 * @param {dcv.auth.ISaslStep=} [properties] Properties to set
                 */
                function SaslStep(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * The response to the challenge
                 * @member {Uint8Array} authData
                 * @memberof dcv.auth.SaslStep
                 * @instance
                 */
                SaslStep.prototype.authData = $util.newBuffer([]);
    
                /**
                 * Creates a new SaslStep instance using the specified properties.
                 * @function create
                 * @memberof dcv.auth.SaslStep
                 * @static
                 * @param {dcv.auth.ISaslStep=} [properties] Properties to set
                 * @returns {dcv.auth.SaslStep} SaslStep instance
                 */
                SaslStep.create = function create(properties) {
                    return new SaslStep(properties);
                };
    
                /**
                 * Encodes the specified SaslStep message. Does not implicitly {@link dcv.auth.SaslStep.verify|verify} messages.
                 * @function encode
                 * @memberof dcv.auth.SaslStep
                 * @static
                 * @param {dcv.auth.ISaslStep} message SaslStep message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SaslStep.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        writer.uint32(/* id 1, wireType 2 =*/10).bytes(message.authData);
                    return writer;
                };
    
                /**
                 * Encodes the specified SaslStep message, length delimited. Does not implicitly {@link dcv.auth.SaslStep.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof dcv.auth.SaslStep
                 * @static
                 * @param {dcv.auth.ISaslStep} message SaslStep message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SaslStep.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a SaslStep message from the specified reader or buffer.
                 * @function decode
                 * @memberof dcv.auth.SaslStep
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {dcv.auth.SaslStep} SaslStep
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SaslStep.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.SaslStep();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.authData = reader.bytes();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a SaslStep message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof dcv.auth.SaslStep
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {dcv.auth.SaslStep} SaslStep
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SaslStep.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a SaslStep message.
                 * @function verify
                 * @memberof dcv.auth.SaslStep
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                SaslStep.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        if (!(message.authData && typeof message.authData.length === "number" || $util.isString(message.authData)))
                            return "authData: buffer expected";
                    return null;
                };
    
                /**
                 * Creates a SaslStep message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof dcv.auth.SaslStep
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {dcv.auth.SaslStep} SaslStep
                 */
                SaslStep.fromObject = function fromObject(object) {
                    if (object instanceof $root.dcv.auth.SaslStep)
                        return object;
                    var message = new $root.dcv.auth.SaslStep();
                    if (object.authData != null)
                        if (typeof object.authData === "string")
                            $util.base64.decode(object.authData, message.authData = $util.newBuffer($util.base64.length(object.authData)), 0);
                        else if (object.authData.length)
                            message.authData = object.authData;
                    return message;
                };
    
                /**
                 * Creates a plain object from a SaslStep message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof dcv.auth.SaslStep
                 * @static
                 * @param {dcv.auth.SaslStep} message SaslStep
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                SaslStep.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults)
                        object.authData = options.bytes === String ? "" : [];
                    if (message.authData != null && message.hasOwnProperty("authData"))
                        object.authData = options.bytes === String ? $util.base64.encode(message.authData, 0, message.authData.length) : options.bytes === Array ? Array.prototype.slice.call(message.authData) : message.authData;
                    return object;
                };
    
                /**
                 * Converts this SaslStep to JSON.
                 * @function toJSON
                 * @memberof dcv.auth.SaslStep
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                SaslStep.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                return SaslStep;
            })();
    
            auth.AuthenticationResult = (function() {
    
                /**
                 * Properties of an AuthenticationResult.
                 * @memberof dcv.auth
                 * @interface IAuthenticationResult
                 * @property {dcv.auth.AuthenticationResult.Result|null} [resultValue] Wheter the client succesfully authenticated with the server (OK) or not (FAIL)
                 * @property {Array.<dcv.auth.AuthenticationResult.ISessionToken>|null} [sessionTokens] AuthenticationResult sessionTokens
                 * @property {number|null} [retriesLeft] AuthenticationResult retriesLeft
                 */
    
                /**
                 * Constructs a new AuthenticationResult.
                 * @memberof dcv.auth
                 * @classdesc Represents an AuthenticationResult.
                 * @implements IAuthenticationResult
                 * @constructor
                 * @param {dcv.auth.IAuthenticationResult=} [properties] Properties to set
                 */
                function AuthenticationResult(properties) {
                    this.sessionTokens = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Wheter the client succesfully authenticated with the server (OK) or not (FAIL)
                 * @member {dcv.auth.AuthenticationResult.Result} resultValue
                 * @memberof dcv.auth.AuthenticationResult
                 * @instance
                 */
                AuthenticationResult.prototype.resultValue = 0;
    
                /**
                 * AuthenticationResult sessionTokens.
                 * @member {Array.<dcv.auth.AuthenticationResult.ISessionToken>} sessionTokens
                 * @memberof dcv.auth.AuthenticationResult
                 * @instance
                 */
                AuthenticationResult.prototype.sessionTokens = $util.emptyArray;
    
                /**
                 * AuthenticationResult retriesLeft.
                 * @member {number} retriesLeft
                 * @memberof dcv.auth.AuthenticationResult
                 * @instance
                 */
                AuthenticationResult.prototype.retriesLeft = 0;
    
                /**
                 * Creates a new AuthenticationResult instance using the specified properties.
                 * @function create
                 * @memberof dcv.auth.AuthenticationResult
                 * @static
                 * @param {dcv.auth.IAuthenticationResult=} [properties] Properties to set
                 * @returns {dcv.auth.AuthenticationResult} AuthenticationResult instance
                 */
                AuthenticationResult.create = function create(properties) {
                    return new AuthenticationResult(properties);
                };
    
                /**
                 * Encodes the specified AuthenticationResult message. Does not implicitly {@link dcv.auth.AuthenticationResult.verify|verify} messages.
                 * @function encode
                 * @memberof dcv.auth.AuthenticationResult
                 * @static
                 * @param {dcv.auth.IAuthenticationResult} message AuthenticationResult message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                AuthenticationResult.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.resultValue != null && message.hasOwnProperty("resultValue"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int32(message.resultValue);
                    if (message.sessionTokens != null && message.sessionTokens.length)
                        for (var i = 0; i < message.sessionTokens.length; ++i)
                            $root.dcv.auth.AuthenticationResult.SessionToken.encode(message.sessionTokens[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                    if (message.retriesLeft != null && message.hasOwnProperty("retriesLeft"))
                        writer.uint32(/* id 20, wireType 0 =*/160).uint32(message.retriesLeft);
                    return writer;
                };
    
                /**
                 * Encodes the specified AuthenticationResult message, length delimited. Does not implicitly {@link dcv.auth.AuthenticationResult.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof dcv.auth.AuthenticationResult
                 * @static
                 * @param {dcv.auth.IAuthenticationResult} message AuthenticationResult message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                AuthenticationResult.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an AuthenticationResult message from the specified reader or buffer.
                 * @function decode
                 * @memberof dcv.auth.AuthenticationResult
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {dcv.auth.AuthenticationResult} AuthenticationResult
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                AuthenticationResult.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.AuthenticationResult();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.resultValue = reader.int32();
                            break;
                        case 10:
                            if (!(message.sessionTokens && message.sessionTokens.length))
                                message.sessionTokens = [];
                            message.sessionTokens.push($root.dcv.auth.AuthenticationResult.SessionToken.decode(reader, reader.uint32()));
                            break;
                        case 20:
                            message.retriesLeft = reader.uint32();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an AuthenticationResult message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof dcv.auth.AuthenticationResult
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {dcv.auth.AuthenticationResult} AuthenticationResult
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                AuthenticationResult.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an AuthenticationResult message.
                 * @function verify
                 * @memberof dcv.auth.AuthenticationResult
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                AuthenticationResult.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.resultValue != null && message.hasOwnProperty("resultValue"))
                        switch (message.resultValue) {
                        default:
                            return "resultValue: enum value expected";
                        case 0:
                        case 1:
                            break;
                        }
                    if (message.sessionTokens != null && message.hasOwnProperty("sessionTokens")) {
                        if (!Array.isArray(message.sessionTokens))
                            return "sessionTokens: array expected";
                        for (var i = 0; i < message.sessionTokens.length; ++i) {
                            var error = $root.dcv.auth.AuthenticationResult.SessionToken.verify(message.sessionTokens[i]);
                            if (error)
                                return "sessionTokens." + error;
                        }
                    }
                    if (message.retriesLeft != null && message.hasOwnProperty("retriesLeft"))
                        if (!$util.isInteger(message.retriesLeft))
                            return "retriesLeft: integer expected";
                    return null;
                };
    
                /**
                 * Creates an AuthenticationResult message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof dcv.auth.AuthenticationResult
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {dcv.auth.AuthenticationResult} AuthenticationResult
                 */
                AuthenticationResult.fromObject = function fromObject(object) {
                    if (object instanceof $root.dcv.auth.AuthenticationResult)
                        return object;
                    var message = new $root.dcv.auth.AuthenticationResult();
                    switch (object.resultValue) {
                    case "FAIL":
                    case 0:
                        message.resultValue = 0;
                        break;
                    case "OK":
                    case 1:
                        message.resultValue = 1;
                        break;
                    }
                    if (object.sessionTokens) {
                        if (!Array.isArray(object.sessionTokens))
                            throw TypeError(".dcv.auth.AuthenticationResult.sessionTokens: array expected");
                        message.sessionTokens = [];
                        for (var i = 0; i < object.sessionTokens.length; ++i) {
                            if (typeof object.sessionTokens[i] !== "object")
                                throw TypeError(".dcv.auth.AuthenticationResult.sessionTokens: object expected");
                            message.sessionTokens[i] = $root.dcv.auth.AuthenticationResult.SessionToken.fromObject(object.sessionTokens[i]);
                        }
                    }
                    if (object.retriesLeft != null)
                        message.retriesLeft = object.retriesLeft >>> 0;
                    return message;
                };
    
                /**
                 * Creates a plain object from an AuthenticationResult message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof dcv.auth.AuthenticationResult
                 * @static
                 * @param {dcv.auth.AuthenticationResult} message AuthenticationResult
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                AuthenticationResult.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.sessionTokens = [];
                    if (options.defaults) {
                        object.resultValue = options.enums === String ? "FAIL" : 0;
                        object.retriesLeft = 0;
                    }
                    if (message.resultValue != null && message.hasOwnProperty("resultValue"))
                        object.resultValue = options.enums === String ? $root.dcv.auth.AuthenticationResult.Result[message.resultValue] : message.resultValue;
                    if (message.sessionTokens && message.sessionTokens.length) {
                        object.sessionTokens = [];
                        for (var j = 0; j < message.sessionTokens.length; ++j)
                            object.sessionTokens[j] = $root.dcv.auth.AuthenticationResult.SessionToken.toObject(message.sessionTokens[j], options);
                    }
                    if (message.retriesLeft != null && message.hasOwnProperty("retriesLeft"))
                        object.retriesLeft = message.retriesLeft;
                    return object;
                };
    
                /**
                 * Converts this AuthenticationResult to JSON.
                 * @function toJSON
                 * @memberof dcv.auth.AuthenticationResult
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                AuthenticationResult.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Enums the possible results of the authentication procedure
                 * @name dcv.auth.AuthenticationResult.Result
                 * @enum {string}
                 * @property {number} FAIL=0 The client failed to correctly authenticate with the server
                 * @property {number} OK=1 The client succesfully authenticated with the server
                 */
                AuthenticationResult.Result = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "FAIL"] = 0;
                    values[valuesById[1] = "OK"] = 1;
                    return values;
                })();
    
                AuthenticationResult.SessionToken = (function() {
    
                    /**
                     * Properties of a SessionToken.
                     * @memberof dcv.auth.AuthenticationResult
                     * @interface ISessionToken
                     * @property {string|null} [sessionId] SessionToken sessionId
                     * @property {string|null} [authenticationToken] SessionToken authenticationToken
                     */
    
                    /**
                     * Constructs a new SessionToken.
                     * @memberof dcv.auth.AuthenticationResult
                     * @classdesc Represents a SessionToken.
                     * @implements ISessionToken
                     * @constructor
                     * @param {dcv.auth.AuthenticationResult.ISessionToken=} [properties] Properties to set
                     */
                    function SessionToken(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * SessionToken sessionId.
                     * @member {string} sessionId
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @instance
                     */
                    SessionToken.prototype.sessionId = "";
    
                    /**
                     * SessionToken authenticationToken.
                     * @member {string} authenticationToken
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @instance
                     */
                    SessionToken.prototype.authenticationToken = "";
    
                    /**
                     * Creates a new SessionToken instance using the specified properties.
                     * @function create
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @static
                     * @param {dcv.auth.AuthenticationResult.ISessionToken=} [properties] Properties to set
                     * @returns {dcv.auth.AuthenticationResult.SessionToken} SessionToken instance
                     */
                    SessionToken.create = function create(properties) {
                        return new SessionToken(properties);
                    };
    
                    /**
                     * Encodes the specified SessionToken message. Does not implicitly {@link dcv.auth.AuthenticationResult.SessionToken.verify|verify} messages.
                     * @function encode
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @static
                     * @param {dcv.auth.AuthenticationResult.ISessionToken} message SessionToken message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    SessionToken.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.sessionId != null && message.hasOwnProperty("sessionId"))
                            writer.uint32(/* id 1, wireType 2 =*/10).string(message.sessionId);
                        if (message.authenticationToken != null && message.hasOwnProperty("authenticationToken"))
                            writer.uint32(/* id 10, wireType 2 =*/82).string(message.authenticationToken);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified SessionToken message, length delimited. Does not implicitly {@link dcv.auth.AuthenticationResult.SessionToken.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @static
                     * @param {dcv.auth.AuthenticationResult.ISessionToken} message SessionToken message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    SessionToken.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes a SessionToken message from the specified reader or buffer.
                     * @function decode
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {dcv.auth.AuthenticationResult.SessionToken} SessionToken
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    SessionToken.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.AuthenticationResult.SessionToken();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1:
                                message.sessionId = reader.string();
                                break;
                            case 10:
                                message.authenticationToken = reader.string();
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes a SessionToken message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {dcv.auth.AuthenticationResult.SessionToken} SessionToken
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    SessionToken.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies a SessionToken message.
                     * @function verify
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    SessionToken.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.sessionId != null && message.hasOwnProperty("sessionId"))
                            if (!$util.isString(message.sessionId))
                                return "sessionId: string expected";
                        if (message.authenticationToken != null && message.hasOwnProperty("authenticationToken"))
                            if (!$util.isString(message.authenticationToken))
                                return "authenticationToken: string expected";
                        return null;
                    };
    
                    /**
                     * Creates a SessionToken message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {dcv.auth.AuthenticationResult.SessionToken} SessionToken
                     */
                    SessionToken.fromObject = function fromObject(object) {
                        if (object instanceof $root.dcv.auth.AuthenticationResult.SessionToken)
                            return object;
                        var message = new $root.dcv.auth.AuthenticationResult.SessionToken();
                        if (object.sessionId != null)
                            message.sessionId = String(object.sessionId);
                        if (object.authenticationToken != null)
                            message.authenticationToken = String(object.authenticationToken);
                        return message;
                    };
    
                    /**
                     * Creates a plain object from a SessionToken message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @static
                     * @param {dcv.auth.AuthenticationResult.SessionToken} message SessionToken
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    SessionToken.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.sessionId = "";
                            object.authenticationToken = "";
                        }
                        if (message.sessionId != null && message.hasOwnProperty("sessionId"))
                            object.sessionId = message.sessionId;
                        if (message.authenticationToken != null && message.hasOwnProperty("authenticationToken"))
                            object.authenticationToken = message.authenticationToken;
                        return object;
                    };
    
                    /**
                     * Converts this SessionToken to JSON.
                     * @function toJSON
                     * @memberof dcv.auth.AuthenticationResult.SessionToken
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    SessionToken.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    return SessionToken;
                })();
    
                return AuthenticationResult;
            })();
    
            auth.ClientMessage = (function() {
    
                /**
                 * Properties of a ClientMessage.
                 * @memberof dcv.auth
                 * @interface IClientMessage
                 * @property {dcv.auth.IAuthenticationRequest|null} [authenticationRequest] ClientMessage authenticationRequest
                 * @property {dcv.auth.ISaslStart|null} [saslStart] ClientMessage saslStart
                 * @property {dcv.auth.ISaslStep|null} [saslStep] ClientMessage saslStep
                 */
    
                /**
                 * Constructs a new ClientMessage.
                 * @memberof dcv.auth
                 * @classdesc Represents a ClientMessage.
                 * @implements IClientMessage
                 * @constructor
                 * @param {dcv.auth.IClientMessage=} [properties] Properties to set
                 */
                function ClientMessage(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ClientMessage authenticationRequest.
                 * @member {dcv.auth.IAuthenticationRequest|null|undefined} authenticationRequest
                 * @memberof dcv.auth.ClientMessage
                 * @instance
                 */
                ClientMessage.prototype.authenticationRequest = null;
    
                /**
                 * ClientMessage saslStart.
                 * @member {dcv.auth.ISaslStart|null|undefined} saslStart
                 * @memberof dcv.auth.ClientMessage
                 * @instance
                 */
                ClientMessage.prototype.saslStart = null;
    
                /**
                 * ClientMessage saslStep.
                 * @member {dcv.auth.ISaslStep|null|undefined} saslStep
                 * @memberof dcv.auth.ClientMessage
                 * @instance
                 */
                ClientMessage.prototype.saslStep = null;
    
                // OneOf field names bound to virtual getters and setters
                var $oneOfFields;
    
                /**
                 * ClientMessage msg.
                 * @member {"authenticationRequest"|"saslStart"|"saslStep"|undefined} msg
                 * @memberof dcv.auth.ClientMessage
                 * @instance
                 */
                Object.defineProperty(ClientMessage.prototype, "msg", {
                    get: $util.oneOfGetter($oneOfFields = ["authenticationRequest", "saslStart", "saslStep"]),
                    set: $util.oneOfSetter($oneOfFields)
                });
    
                /**
                 * Creates a new ClientMessage instance using the specified properties.
                 * @function create
                 * @memberof dcv.auth.ClientMessage
                 * @static
                 * @param {dcv.auth.IClientMessage=} [properties] Properties to set
                 * @returns {dcv.auth.ClientMessage} ClientMessage instance
                 */
                ClientMessage.create = function create(properties) {
                    return new ClientMessage(properties);
                };
    
                /**
                 * Encodes the specified ClientMessage message. Does not implicitly {@link dcv.auth.ClientMessage.verify|verify} messages.
                 * @function encode
                 * @memberof dcv.auth.ClientMessage
                 * @static
                 * @param {dcv.auth.IClientMessage} message ClientMessage message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ClientMessage.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.authenticationRequest != null && message.hasOwnProperty("authenticationRequest"))
                        $root.dcv.auth.AuthenticationRequest.encode(message.authenticationRequest, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                    if (message.saslStart != null && message.hasOwnProperty("saslStart"))
                        $root.dcv.auth.SaslStart.encode(message.saslStart, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                    if (message.saslStep != null && message.hasOwnProperty("saslStep"))
                        $root.dcv.auth.SaslStep.encode(message.saslStep, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified ClientMessage message, length delimited. Does not implicitly {@link dcv.auth.ClientMessage.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof dcv.auth.ClientMessage
                 * @static
                 * @param {dcv.auth.IClientMessage} message ClientMessage message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ClientMessage.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ClientMessage message from the specified reader or buffer.
                 * @function decode
                 * @memberof dcv.auth.ClientMessage
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {dcv.auth.ClientMessage} ClientMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ClientMessage.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.ClientMessage();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 10:
                            message.authenticationRequest = $root.dcv.auth.AuthenticationRequest.decode(reader, reader.uint32());
                            break;
                        case 20:
                            message.saslStart = $root.dcv.auth.SaslStart.decode(reader, reader.uint32());
                            break;
                        case 30:
                            message.saslStep = $root.dcv.auth.SaslStep.decode(reader, reader.uint32());
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ClientMessage message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof dcv.auth.ClientMessage
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {dcv.auth.ClientMessage} ClientMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ClientMessage.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ClientMessage message.
                 * @function verify
                 * @memberof dcv.auth.ClientMessage
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ClientMessage.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    var properties = {};
                    if (message.authenticationRequest != null && message.hasOwnProperty("authenticationRequest")) {
                        properties.msg = 1;
                        {
                            var error = $root.dcv.auth.AuthenticationRequest.verify(message.authenticationRequest);
                            if (error)
                                return "authenticationRequest." + error;
                        }
                    }
                    if (message.saslStart != null && message.hasOwnProperty("saslStart")) {
                        if (properties.msg === 1)
                            return "msg: multiple values";
                        properties.msg = 1;
                        {
                            var error = $root.dcv.auth.SaslStart.verify(message.saslStart);
                            if (error)
                                return "saslStart." + error;
                        }
                    }
                    if (message.saslStep != null && message.hasOwnProperty("saslStep")) {
                        if (properties.msg === 1)
                            return "msg: multiple values";
                        properties.msg = 1;
                        {
                            var error = $root.dcv.auth.SaslStep.verify(message.saslStep);
                            if (error)
                                return "saslStep." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a ClientMessage message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof dcv.auth.ClientMessage
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {dcv.auth.ClientMessage} ClientMessage
                 */
                ClientMessage.fromObject = function fromObject(object) {
                    if (object instanceof $root.dcv.auth.ClientMessage)
                        return object;
                    var message = new $root.dcv.auth.ClientMessage();
                    if (object.authenticationRequest != null) {
                        if (typeof object.authenticationRequest !== "object")
                            throw TypeError(".dcv.auth.ClientMessage.authenticationRequest: object expected");
                        message.authenticationRequest = $root.dcv.auth.AuthenticationRequest.fromObject(object.authenticationRequest);
                    }
                    if (object.saslStart != null) {
                        if (typeof object.saslStart !== "object")
                            throw TypeError(".dcv.auth.ClientMessage.saslStart: object expected");
                        message.saslStart = $root.dcv.auth.SaslStart.fromObject(object.saslStart);
                    }
                    if (object.saslStep != null) {
                        if (typeof object.saslStep !== "object")
                            throw TypeError(".dcv.auth.ClientMessage.saslStep: object expected");
                        message.saslStep = $root.dcv.auth.SaslStep.fromObject(object.saslStep);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a ClientMessage message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof dcv.auth.ClientMessage
                 * @static
                 * @param {dcv.auth.ClientMessage} message ClientMessage
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ClientMessage.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (message.authenticationRequest != null && message.hasOwnProperty("authenticationRequest")) {
                        object.authenticationRequest = $root.dcv.auth.AuthenticationRequest.toObject(message.authenticationRequest, options);
                        if (options.oneofs)
                            object.msg = "authenticationRequest";
                    }
                    if (message.saslStart != null && message.hasOwnProperty("saslStart")) {
                        object.saslStart = $root.dcv.auth.SaslStart.toObject(message.saslStart, options);
                        if (options.oneofs)
                            object.msg = "saslStart";
                    }
                    if (message.saslStep != null && message.hasOwnProperty("saslStep")) {
                        object.saslStep = $root.dcv.auth.SaslStep.toObject(message.saslStep, options);
                        if (options.oneofs)
                            object.msg = "saslStep";
                    }
                    return object;
                };
    
                /**
                 * Converts this ClientMessage to JSON.
                 * @function toJSON
                 * @memberof dcv.auth.ClientMessage
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ClientMessage.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                return ClientMessage;
            })();
    
            auth.ServerMessage = (function() {
    
                /**
                 * Properties of a ServerMessage.
                 * @memberof dcv.auth
                 * @interface IServerMessage
                 * @property {dcv.auth.IAuthenticationInit|null} [authenticationInit] ServerMessage authenticationInit
                 * @property {dcv.auth.ISaslChallenge|null} [saslChallenge] ServerMessage saslChallenge
                 * @property {dcv.auth.IAuthenticationResult|null} [authenticationResult] ServerMessage authenticationResult
                 */
    
                /**
                 * Constructs a new ServerMessage.
                 * @memberof dcv.auth
                 * @classdesc Represents a ServerMessage.
                 * @implements IServerMessage
                 * @constructor
                 * @param {dcv.auth.IServerMessage=} [properties] Properties to set
                 */
                function ServerMessage(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ServerMessage authenticationInit.
                 * @member {dcv.auth.IAuthenticationInit|null|undefined} authenticationInit
                 * @memberof dcv.auth.ServerMessage
                 * @instance
                 */
                ServerMessage.prototype.authenticationInit = null;
    
                /**
                 * ServerMessage saslChallenge.
                 * @member {dcv.auth.ISaslChallenge|null|undefined} saslChallenge
                 * @memberof dcv.auth.ServerMessage
                 * @instance
                 */
                ServerMessage.prototype.saslChallenge = null;
    
                /**
                 * ServerMessage authenticationResult.
                 * @member {dcv.auth.IAuthenticationResult|null|undefined} authenticationResult
                 * @memberof dcv.auth.ServerMessage
                 * @instance
                 */
                ServerMessage.prototype.authenticationResult = null;
    
                // OneOf field names bound to virtual getters and setters
                var $oneOfFields;
    
                /**
                 * ServerMessage msg.
                 * @member {"authenticationInit"|"saslChallenge"|"authenticationResult"|undefined} msg
                 * @memberof dcv.auth.ServerMessage
                 * @instance
                 */
                Object.defineProperty(ServerMessage.prototype, "msg", {
                    get: $util.oneOfGetter($oneOfFields = ["authenticationInit", "saslChallenge", "authenticationResult"]),
                    set: $util.oneOfSetter($oneOfFields)
                });
    
                /**
                 * Creates a new ServerMessage instance using the specified properties.
                 * @function create
                 * @memberof dcv.auth.ServerMessage
                 * @static
                 * @param {dcv.auth.IServerMessage=} [properties] Properties to set
                 * @returns {dcv.auth.ServerMessage} ServerMessage instance
                 */
                ServerMessage.create = function create(properties) {
                    return new ServerMessage(properties);
                };
    
                /**
                 * Encodes the specified ServerMessage message. Does not implicitly {@link dcv.auth.ServerMessage.verify|verify} messages.
                 * @function encode
                 * @memberof dcv.auth.ServerMessage
                 * @static
                 * @param {dcv.auth.IServerMessage} message ServerMessage message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServerMessage.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.authenticationInit != null && message.hasOwnProperty("authenticationInit"))
                        $root.dcv.auth.AuthenticationInit.encode(message.authenticationInit, writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
                    if (message.saslChallenge != null && message.hasOwnProperty("saslChallenge"))
                        $root.dcv.auth.SaslChallenge.encode(message.saslChallenge, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
                    if (message.authenticationResult != null && message.hasOwnProperty("authenticationResult"))
                        $root.dcv.auth.AuthenticationResult.encode(message.authenticationResult, writer.uint32(/* id 30, wireType 2 =*/242).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified ServerMessage message, length delimited. Does not implicitly {@link dcv.auth.ServerMessage.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof dcv.auth.ServerMessage
                 * @static
                 * @param {dcv.auth.IServerMessage} message ServerMessage message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServerMessage.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ServerMessage message from the specified reader or buffer.
                 * @function decode
                 * @memberof dcv.auth.ServerMessage
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {dcv.auth.ServerMessage} ServerMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServerMessage.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.dcv.auth.ServerMessage();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 10:
                            message.authenticationInit = $root.dcv.auth.AuthenticationInit.decode(reader, reader.uint32());
                            break;
                        case 20:
                            message.saslChallenge = $root.dcv.auth.SaslChallenge.decode(reader, reader.uint32());
                            break;
                        case 30:
                            message.authenticationResult = $root.dcv.auth.AuthenticationResult.decode(reader, reader.uint32());
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ServerMessage message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof dcv.auth.ServerMessage
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {dcv.auth.ServerMessage} ServerMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServerMessage.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ServerMessage message.
                 * @function verify
                 * @memberof dcv.auth.ServerMessage
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ServerMessage.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    var properties = {};
                    if (message.authenticationInit != null && message.hasOwnProperty("authenticationInit")) {
                        properties.msg = 1;
                        {
                            var error = $root.dcv.auth.AuthenticationInit.verify(message.authenticationInit);
                            if (error)
                                return "authenticationInit." + error;
                        }
                    }
                    if (message.saslChallenge != null && message.hasOwnProperty("saslChallenge")) {
                        if (properties.msg === 1)
                            return "msg: multiple values";
                        properties.msg = 1;
                        {
                            var error = $root.dcv.auth.SaslChallenge.verify(message.saslChallenge);
                            if (error)
                                return "saslChallenge." + error;
                        }
                    }
                    if (message.authenticationResult != null && message.hasOwnProperty("authenticationResult")) {
                        if (properties.msg === 1)
                            return "msg: multiple values";
                        properties.msg = 1;
                        {
                            var error = $root.dcv.auth.AuthenticationResult.verify(message.authenticationResult);
                            if (error)
                                return "authenticationResult." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a ServerMessage message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof dcv.auth.ServerMessage
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {dcv.auth.ServerMessage} ServerMessage
                 */
                ServerMessage.fromObject = function fromObject(object) {
                    if (object instanceof $root.dcv.auth.ServerMessage)
                        return object;
                    var message = new $root.dcv.auth.ServerMessage();
                    if (object.authenticationInit != null) {
                        if (typeof object.authenticationInit !== "object")
                            throw TypeError(".dcv.auth.ServerMessage.authenticationInit: object expected");
                        message.authenticationInit = $root.dcv.auth.AuthenticationInit.fromObject(object.authenticationInit);
                    }
                    if (object.saslChallenge != null) {
                        if (typeof object.saslChallenge !== "object")
                            throw TypeError(".dcv.auth.ServerMessage.saslChallenge: object expected");
                        message.saslChallenge = $root.dcv.auth.SaslChallenge.fromObject(object.saslChallenge);
                    }
                    if (object.authenticationResult != null) {
                        if (typeof object.authenticationResult !== "object")
                            throw TypeError(".dcv.auth.ServerMessage.authenticationResult: object expected");
                        message.authenticationResult = $root.dcv.auth.AuthenticationResult.fromObject(object.authenticationResult);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a ServerMessage message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof dcv.auth.ServerMessage
                 * @static
                 * @param {dcv.auth.ServerMessage} message ServerMessage
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ServerMessage.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (message.authenticationInit != null && message.hasOwnProperty("authenticationInit")) {
                        object.authenticationInit = $root.dcv.auth.AuthenticationInit.toObject(message.authenticationInit, options);
                        if (options.oneofs)
                            object.msg = "authenticationInit";
                    }
                    if (message.saslChallenge != null && message.hasOwnProperty("saslChallenge")) {
                        object.saslChallenge = $root.dcv.auth.SaslChallenge.toObject(message.saslChallenge, options);
                        if (options.oneofs)
                            object.msg = "saslChallenge";
                    }
                    if (message.authenticationResult != null && message.hasOwnProperty("authenticationResult")) {
                        object.authenticationResult = $root.dcv.auth.AuthenticationResult.toObject(message.authenticationResult, options);
                        if (options.oneofs)
                            object.msg = "authenticationResult";
                    }
                    return object;
                };
    
                /**
                 * Converts this ServerMessage to JSON.
                 * @function toJSON
                 * @memberof dcv.auth.ServerMessage
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ServerMessage.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                return ServerMessage;
            })();
    
            return auth;
        })();
    
        return dcv;
    })();

    return $root;
});
