"use strict";

require.config({

    // All thid party deps are in lib
    baseUrl: "js/lib",

    shim: {

        bootstrap: {
            deps: ["jquery"]
        }
    },

    paths: {
        long: "protobufjs/long",
        bytebuffer: "protobufjs/bytebuffer",
        protobuf: "protobufjs/protobuf",
        minimal: "protobufjs/minimal",

        saslfactory: "sasl/sasl",

        loglevel: "loglevel/loglevel",

        jquery: "jquery/jquery-2.1.4",

        // FIXME: We should just import draggable api, instead of entire jquery-ui
        jqueryui: "jquery-ui/jquery-ui",

        bootstrap: "bootstrap/bootstrap.min",

        bowser: "bowser/bowser",

        // the DCV library
        dcv: "dcv/dcv",

        // our modules are in app
        app: "../app",

        // html templates
        templates: "../../templates",

        // images
        images: "../../images"
    },

    // Wait indefinitely. since if the modules do not load we are just an
    // empty page and there is no feedback anyway
    waitSeconds: 0
});

// force dcv.js to be loaded dynamically so we have a chance
// to fetch the source map file (if available)
require(["app/main", "dcv"]);

/* ex:set ts=4 et: */
